Bug 1127037 - when g++ specify -c option, default no diagnostics color output
Summary: when g++ specify -c option, default no diagnostics color output
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: ccache
Version: 22
Hardware: All
OS: Linux
unspecified
low
Target Milestone: ---
Assignee: Ville Skyttä
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-08-06 02:56 UTC by ccsheller
Modified: 2016-07-19 20:06 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-07-19 20:06:04 UTC


Attachments (Terms of Use)
diagnostics color (11.30 KB, image/png)
2014-08-06 02:56 UTC, ccsheller
no flags Details

Description ccsheller 2014-08-06 02:56:43 UTC
Created attachment 924336 [details]
diagnostics color

test code :
#include <cstring>

int main()
{
        int i=1;
        int *j = i;
        return 0;
}

in shell $g++ test.cxx
will have a diagnostics color  output.

but $g++ -c test.cxx and $g++ -c -fdiagnostics-color=auto test.cxx
the output is black.

I just use $g++ -c -fdiagnostics-color=always test.cxx.
so -c and default diagnostics-color not compatible

Comment 1 ccsheller 2014-08-06 05:26:04 UTC
when i remove ccache,the output have color.

Comment 2 Jakub Jelinek 2014-08-06 06:52:00 UTC
Don't use ccache then, this is something beyond control of gcc.

Comment 3 Ville Skyttä 2014-11-30 11:25:44 UTC
ccache 3.2 (entering rawhide soon) seems to have this partially fixed, these give colorized output with it:

    g++ test.cxx
    g++ -c -fdiagnostics-color=auto test.cxx

...but this still doesn't:

    g++ -c test.cxx

Comment 4 Joel Rosdahl 2014-12-20 14:40:28 UTC
Don't you need to set GCC_COLORS (or pass -fdiagnostics-color) to get color diagnostics from GCC in Fedora?

/ccache upstream maintainer, not running Fedora

Comment 5 Jakub Jelinek 2014-12-20 15:59:21 UTC
Fedora has the same default as upstream trunk, i.e. even if GCC_COLORS env var is not defined, colors are output if stderr is a tty and TERM is not dumb.
I.e. as if trunk has been configured with the default --with-diagnostics-color=auto.  Upstream 4.9 on the other side defaults to trunk's --with-diagnostics-color=auto-if-env.  See https://gcc.gnu.org/gcc-5/changes.html for more details.

Comment 6 Fedora End Of Life 2015-05-29 12:34:10 UTC
This message is a reminder that Fedora 20 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 20. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '20'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 20 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 7 Joel Rosdahl 2015-08-09 19:19:42 UTC
From a ccache point of view, I don't see any good solution for this issue. The problem is that ccache needs to pass -fdiagnostics-color to the preprocessor to get colored output and that is currently done if GCC_COLORS is set. ccache can't just pass -fdiagnostics-color unconditionally since it doesn't know whether the compiler is new enough to support it.

Any ideas?

Comment 8 Fedora End Of Life 2016-07-19 20:06:04 UTC
Fedora 22 changed to end-of-life (EOL) status on 2016-07-19. Fedora 22 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.